// ~jl007-010pr[(HMZp)
#include <windows.h>
#include <d3d11_1.h>
#include <d3dcompiler.h>
#include <directxmath.h>
#include <directxcolors.h>
#include <Shlobj.h>
#include "WICTextureLoader.h"

#pragma comment(lib,"d3d11.lib")
#pragma comment(lib,"d3dcompiler.lib")

using namespace DirectX;

struct SimpleVertex{
  XMFLOAT3 Pos;
  XMFLOAT2 Tex;
};

struct ConstantBuffer{
  XMMATRIX mWorld;
  XMMATRIX mView;
  XMMATRIX mProjection;
};

#define MAXPAGENUM 200

int g_pagenum;
int g_nowpage=0;
int diffmode=0;
float g_angle;
float g_now_angle;
float g_step_angle;
ULONGLONG g_now_time;

HINSTANCE               g_hInst = nullptr;
HWND                    g_hWnd = nullptr;
D3D_DRIVER_TYPE         g_driverType = D3D_DRIVER_TYPE_NULL;
D3D_FEATURE_LEVEL       g_featureLevel = D3D_FEATURE_LEVEL_11_0;
ID3D11Device*           g_pd3dDevice = nullptr;
ID3D11DeviceContext*    g_pImmediateContext = nullptr;
IDXGISwapChain*         g_pSwapChain = nullptr;
ID3D11RenderTargetView* g_pRenderTargetView = nullptr;
ID3D11Texture2D*        g_pDepthStencil = nullptr;
ID3D11DepthStencilView* g_pDepthStencilView = nullptr;
ID3D11VertexShader*     g_pVertexShader = nullptr;
ID3D11PixelShader*      g_pPixelShader = nullptr;
ID3D11InputLayout*      g_pVertexLayout = nullptr;
ID3D11Buffer*           g_pVertexBuffer = nullptr;
ID3D11Buffer*           g_pIndexBuffer = nullptr;
ID3D11Buffer*           g_pConstantBuffer = nullptr;
ID3D11ShaderResourceView* g_pShaderResourceViewL[MAXPAGENUM] ={nullptr};
ID3D11ShaderResourceView* g_pShaderResourceViewR[MAXPAGENUM] ={nullptr};
ID3D11ShaderResourceView* g_pShaderResourceViewLD[MAXPAGENUM] ={nullptr};
ID3D11ShaderResourceView* g_pShaderResourceViewRD[MAXPAGENUM] ={nullptr};
XMMATRIX                g_World;
XMMATRIX                g_ViewL;
XMMATRIX                g_ViewR;
XMMATRIX                g_Projection;

UINT g_width;
UINT g_height;
TCHAR *g_sShaderFile = L"test.fx";
TCHAR g_sFolder[_MAX_PATH];

HRESULT InitWindow( HINSTANCE hInstance, int nCmdShow );
HRESULT InitDevice();
void CleanupDevice();
LRESULT CALLBACK    WndProc( HWND, UINT, WPARAM, LPARAM );
void Render();

// \tH_̎擾
void GetFolder(TCHAR sFolder[]){
  BROWSEINFO      bi;
  LPTSTR          lpBuffer;
  LPITEMIDLIST    pidlRoot;      // uEỸ[gPIDL
  LPITEMIDLIST    pidlBrowse;    // [U[IPIDL
  LPMALLOC        lpMalloc = NULL;

  sFolder[0]=L'\0';
  HRESULT hr = SHGetMalloc(&lpMalloc);
  if(FAILED(hr)) return;

  // uEY󂯎obt@̈̊m
  if ((lpBuffer = (LPWSTR) lpMalloc->Alloc(_MAX_PATH)) == NULL) {
      return;
  }
  // _CAO\̃[gtH_PIDL擾
  if (SHGetSpecialFolderLocation( g_hWnd,
                                  CSIDL_DESKTOP,
                                  &pidlRoot)!=S_OK){
    lpMalloc->Free(lpBuffer);
    return;
  }
  // BROWSEINFO\̂̏lݒ
  bi.hwndOwner = g_hWnd;
  bi.pidlRoot = pidlRoot;
  bi.pszDisplayName = lpBuffer;
  bi.lpszTitle = L"tH_Iĉ";
  bi.ulFlags = 0;
  bi.lpfn = 0;
  bi.lParam = 0;
  // tH_I_CAO̕\ 
  pidlBrowse = SHBrowseForFolder(&bi);
  if (pidlBrowse != NULL) {  
    // PIDL`̖߂l̃t@CVXẽpXɕϊ
    if (SHGetPathFromIDList(pidlBrowse, lpBuffer)){
      lstrcpy(sFolder,lpBuffer);
    }
    // SHBrowseForFolder̖߂lPIDL
    lpMalloc->Free(pidlBrowse);
  }
  // N[Abv
  lpMalloc->Free(pidlRoot); 
  lpMalloc->Free(lpBuffer);
  lpMalloc->Release();
  return;
}

// Gg|Cg
int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine,
                   int nCmdShow){
  MSG msg = {0};

  GetFolder(g_sFolder);
  int length=lstrlen(g_sFolder);
  if(length==0) return 0;
  else if(lstrlen(g_sFolder)>=_MAX_PATH-14){
    MessageBox(nullptr, L"pX܂B", L"Err", MB_OK);
    return 0;
  }

  if( FAILED( InitWindow( hInstance, nCmdShow ) ) )
    return 0;

  if(FAILED(InitDevice())){
    CleanupDevice();
    return 0;
  }

  while( WM_QUIT != msg.message ){
    if(PeekMessage(&msg,nullptr,0,0,PM_REMOVE)){
      TranslateMessage( &msg );
      DispatchMessage( &msg );
    }
    else{
      Render();
    }
  }

  CleanupDevice();

  return ( int )msg.wParam;
}

// EBhENX̓o^ƃEBhE̍쐬
HRESULT InitWindow(HINSTANCE hInstance, int nCmdShow ){
  // EBhENX̓o^
  WNDCLASSEX wcex;
  wcex.cbSize = sizeof( WNDCLASSEX );
  wcex.style = CS_HREDRAW | CS_VREDRAW;
  wcex.lpfnWndProc = WndProc;
  wcex.cbClsExtra = 0;
  wcex.cbWndExtra = 0;
  wcex.hInstance = hInstance;
  wcex.hIcon = (HICON)LoadImage(NULL, IDI_APPLICATION, IMAGE_ICON, 0, 0, LR_SHARED);
  wcex.hCursor = LoadCursor( nullptr, IDC_ARROW );
  wcex.hbrBackground = ( HBRUSH )( COLOR_WINDOW + 1 );
  wcex.lpszMenuName = nullptr;
  wcex.lpszClassName = L"DX11TestClass";
  wcex.hIconSm = (HICON)LoadImage(NULL, IDI_APPLICATION, IMAGE_ICON, 0, 0, LR_SHARED);
  if( !RegisterClassEx(&wcex )) return E_FAIL;

  // EBhE쐬
  g_hInst = hInstance;
  RECT rc = { 0, 0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN) };
  AdjustWindowRect( &rc, WS_POPUP, FALSE );
  g_hWnd = CreateWindow( L"DX11TestClass", L"Direct3D Test1", WS_VISIBLE | WS_POPUP,
                         CW_USEDEFAULT, CW_USEDEFAULT, rc.right - rc.left, rc.bottom - rc.top, nullptr, nullptr, hInstance,
                         nullptr );

  if(!g_hWnd) return E_FAIL;

  ShowWindow( g_hWnd, nCmdShow );
  return S_OK;
}

// VF[_t@C̃RpC(`[gÂ̕܂܎gp)
HRESULT CompileShaderFromFile( WCHAR* szFileName, LPCSTR szEntryPoint, LPCSTR szShaderModel, ID3DBlob** ppBlobOut ){
  HRESULT hr = S_OK;

  DWORD dwShaderFlags = D3DCOMPILE_ENABLE_STRICTNESS;
#if defined( DEBUG ) || defined( _DEBUG )
  // Set the D3DCOMPILE_DEBUG flag to embed debug information in the shaders.
  // Setting this flag improves the shader debugging experience, but still allows 
  // the shaders to be optimized and to run exactly the way they will run in 
  // the release configuration of this program.
  dwShaderFlags |= D3DCOMPILE_DEBUG;
#endif

  ID3DBlob* pErrorBlob;
  hr = D3DCompileFromFile( szFileName, nullptr, nullptr, szEntryPoint, szShaderModel, 
                           dwShaderFlags, 0, ppBlobOut, &pErrorBlob );
  if( FAILED(hr) ){
    if( pErrorBlob != nullptr )
      OutputDebugStringA( (char*)pErrorBlob->GetBufferPointer() );
    if( pErrorBlob ) pErrorBlob->Release();
    return hr;
  }
  if( pErrorBlob ) pErrorBlob->Release();

  return S_OK;
}

// foCXƃobt@̏
HRESULT InitDevice(){
  HRESULT hr = S_OK;
  TCHAR sTextureFile[_MAX_PATH];

  RECT rc;
  GetClientRect( g_hWnd, &rc );
  g_width = GetSystemMetrics(SM_CXSCREEN); //rc.right - rc.left;
  g_height = GetSystemMetrics(SM_CYSCREEN); //rc.bottom - rc.top;

  UINT createDeviceFlags = 0;
#ifdef _DEBUG
  createDeviceFlags |= D3D11_CREATE_DEVICE_DEBUG;
#endif

  D3D_DRIVER_TYPE driverTypes[] ={
    D3D_DRIVER_TYPE_HARDWARE,
    D3D_DRIVER_TYPE_WARP,
    D3D_DRIVER_TYPE_REFERENCE,
  };
  UINT numDriverTypes = ARRAYSIZE( driverTypes );

  D3D_FEATURE_LEVEL featureLevels[] ={
    D3D_FEATURE_LEVEL_11_1,
    D3D_FEATURE_LEVEL_11_0,
    D3D_FEATURE_LEVEL_10_1,
    D3D_FEATURE_LEVEL_10_0,
  };
  UINT numFeatureLevels = ARRAYSIZE( featureLevels );

  DXGI_SWAP_CHAIN_DESC sd;
  ZeroMemory( &sd, sizeof( sd ) );
  sd.BufferCount = 1;
  sd.BufferDesc.Width = g_width;
  sd.BufferDesc.Height = g_height;
  sd.BufferDesc.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
  sd.BufferDesc.RefreshRate.Numerator = 60;
  sd.BufferDesc.RefreshRate.Denominator = 1;
  sd.BufferUsage = DXGI_USAGE_RENDER_TARGET_OUTPUT;
  sd.OutputWindow = g_hWnd;
  sd.SampleDesc.Count = 1;
  sd.SampleDesc.Quality = 0;
  sd.Windowed = TRUE;

  for( UINT driverTypeIndex = 0; driverTypeIndex < numDriverTypes; driverTypeIndex++ ){
    g_driverType = driverTypes[driverTypeIndex];
    hr = D3D11CreateDeviceAndSwapChain( nullptr, g_driverType, nullptr, createDeviceFlags, featureLevels, numFeatureLevels,
                                        D3D11_SDK_VERSION, &sd, &g_pSwapChain, &g_pd3dDevice, &g_featureLevel, &g_pImmediateContext );

    if ( hr == E_INVALIDARG ){
      // DirectX 11.0 platforms will not recognize D3D_FEATURE_LEVEL_11_1 so we need to retry without it
      hr = D3D11CreateDeviceAndSwapChain( nullptr, g_driverType, nullptr, createDeviceFlags, &featureLevels[1], numFeatureLevels - 1,
                                          D3D11_SDK_VERSION, &sd, &g_pSwapChain, &g_pd3dDevice, &g_featureLevel, &g_pImmediateContext );
    }

    if(SUCCEEDED(hr)) break;
  }
  if(FAILED(hr)) return hr;

  // Create a render target view
  ID3D11Texture2D* pBackBuffer = nullptr;
  hr = g_pSwapChain->GetBuffer( 0, __uuidof( ID3D11Texture2D ), ( LPVOID* )&pBackBuffer );
  if(FAILED(hr)) return hr;

  hr = g_pd3dDevice->CreateRenderTargetView( pBackBuffer, nullptr, &g_pRenderTargetView );
  pBackBuffer->Release();
  if(FAILED(hr)) return hr;

  // Create depth stencil texture
  D3D11_TEXTURE2D_DESC descDepth;
  ZeroMemory( &descDepth, sizeof(descDepth) );
  descDepth.Width = g_width;
  descDepth.Height = g_height;
  descDepth.MipLevels = 1;
  descDepth.ArraySize = 1;
  descDepth.Format = DXGI_FORMAT_D24_UNORM_S8_UINT;
  descDepth.SampleDesc.Count = 1;
  descDepth.SampleDesc.Quality = 0;
  descDepth.Usage = D3D11_USAGE_DEFAULT;
  descDepth.BindFlags = D3D11_BIND_DEPTH_STENCIL;
  descDepth.CPUAccessFlags = 0;
  descDepth.MiscFlags = 0;
  hr = g_pd3dDevice->CreateTexture2D( &descDepth, nullptr, &g_pDepthStencil );
  if(FAILED(hr)) return hr;

  // Create the depth stencil view
  D3D11_DEPTH_STENCIL_VIEW_DESC descDSV;
  ZeroMemory( &descDSV, sizeof(descDSV) );
  descDSV.Format = descDepth.Format;
  descDSV.ViewDimension = D3D11_DSV_DIMENSION_TEXTURE2D;
  descDSV.Texture2D.MipSlice = 0;
  hr = g_pd3dDevice->CreateDepthStencilView( g_pDepthStencil, &descDSV, &g_pDepthStencilView );
  if(FAILED(hr)) return hr;

  g_pImmediateContext->OMSetRenderTargets( 1, &g_pRenderTargetView, g_pDepthStencilView );

  // Compile the vertex shader
  ID3DBlob* pVSBlob = nullptr;
  hr = CompileShaderFromFile( g_sShaderFile, "vs_main", "vs_4_0", &pVSBlob );
  if( FAILED( hr ) ){
    MessageBox( nullptr,
                L"The vertex shader file cannot be compiled.  Please run this executable from the directory that contains the FX file.", L"Error", MB_OK );
    return hr;
  }

  // Create the vertex shader
  hr = g_pd3dDevice->CreateVertexShader( pVSBlob->GetBufferPointer(), pVSBlob->GetBufferSize(), nullptr, &g_pVertexShader );
  if(FAILED(hr )){	
    pVSBlob->Release();
    return hr;
  }

  // Define the input layout
  D3D11_INPUT_ELEMENT_DESC layout[] ={
    { "POSITION", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "TEXCOORD", 0, DXGI_FORMAT_R32G32_FLOAT, 0, 12, D3D11_INPUT_PER_VERTEX_DATA, 0 },
  };
  UINT numElements = ARRAYSIZE( layout );

  // Create the input layout
  hr = g_pd3dDevice->CreateInputLayout( layout, numElements, pVSBlob->GetBufferPointer(),
                                        pVSBlob->GetBufferSize(), &g_pVertexLayout );
  pVSBlob->Release();
  if(FAILED(hr)) return hr;

  // Set the input layout
  g_pImmediateContext->IASetInputLayout( g_pVertexLayout );

  // Compile the pixel shader
  ID3DBlob* pPSBlob = nullptr;
  hr = CompileShaderFromFile( g_sShaderFile, "ps_main", "ps_4_0", &pPSBlob );
  if(FAILED(hr)){
    MessageBox( nullptr,
                L"The pixel shader file cannot be compiled.  Please run this executable from the directory that contains the FX file.", L"Error", MB_OK );
    return hr;
  }

  // Create the pixel shader
  hr = g_pd3dDevice->CreatePixelShader( pPSBlob->GetBufferPointer(), pPSBlob->GetBufferSize(), nullptr, &g_pPixelShader );
  pPSBlob->Release();
  if( FAILED( hr ) )
        return hr;

  // Create vertex buffer
  SimpleVertex vertices[] ={
    { XMFLOAT3(-1.0f, -1.0f, 0.0f), XMFLOAT2(0.0f, 1.0f) },
    { XMFLOAT3( 1.0f, -1.0f, 0.0f), XMFLOAT2(1.0f, 1.0f) },
    { XMFLOAT3( 1.0f,  1.0f, 0.0f), XMFLOAT2(1.0f, 0.0f) },
    { XMFLOAT3(-1.0f,  1.0f, 0.0f), XMFLOAT2(0.0f, 0.0f) },
  };
  D3D11_BUFFER_DESC bd;
  ZeroMemory( &bd, sizeof(bd) );
  bd.Usage = D3D11_USAGE_DEFAULT;
  bd.ByteWidth = sizeof( vertices );
  bd.BindFlags = D3D11_BIND_VERTEX_BUFFER;
  bd.CPUAccessFlags = 0;
  D3D11_SUBRESOURCE_DATA InitData;
  ZeroMemory( &InitData, sizeof(InitData) );
  InitData.pSysMem = vertices;
  hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &g_pVertexBuffer );
  if(FAILED(hr))return hr;

  // Set vertex buffer
  UINT stride = sizeof( SimpleVertex );
  UINT offset = 0;
  g_pImmediateContext->IASetVertexBuffers( 0, 1, &g_pVertexBuffer, &stride, &offset );

  // Create index buffer
  WORD indices[] ={
    2,1,0,
    0,3,2,
  };
  bd.Usage = D3D11_USAGE_DEFAULT;
  bd.ByteWidth = sizeof( indices );
  bd.BindFlags = D3D11_BIND_INDEX_BUFFER;
  bd.CPUAccessFlags = 0;
  InitData.pSysMem = indices;
  hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &g_pIndexBuffer );
  if(FAILED(hr)) return hr;

  // Set index buffer
  g_pImmediateContext->IASetIndexBuffer( g_pIndexBuffer, DXGI_FORMAT_R16_UINT, 0 );

  // Set primitive topology
  g_pImmediateContext->IASetPrimitiveTopology( D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST );

  // Create the constant buffer
  bd.Usage = D3D11_USAGE_DEFAULT;
  bd.ByteWidth = sizeof(ConstantBuffer);
  bd.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
  bd.CPUAccessFlags = 0;
  hr = g_pd3dDevice->CreateBuffer( &bd, nullptr, &g_pConstantBuffer );
  if(FAILED(hr)) return hr;

  // Initialize the world matrix
  g_World = XMMatrixScaling(1.0 ,512.0f/360.0f,1);

  // Initialize the view matrix
  float sbase=0.1f;
  XMVECTOR Eye = XMVectorSet( -sbase/2, 0.0f, -3.0f, 0.0f );
  XMVECTOR At = XMVectorSet( -sbase/2, 0.0f, 0.0f, 0.0f );
  XMVECTOR Up = XMVectorSet( 0.0f, 1.0f, 0.0f, 0.0f );
  g_ViewL = XMMatrixLookAtLH( Eye, At, Up );
  Eye = XMVectorSet( sbase/2, 0.0f, -3.0f, 0.0f );
  At = XMVectorSet( sbase/2, 0.0f, 0.0f, 0.0f );
  g_ViewR = XMMatrixLookAtLH( Eye, At, Up );

  // Initialize the projection matrix
  g_Projection = XMMatrixPerspectiveFovLH( XM_PI*60.0/180.0, g_width / (FLOAT)g_height, 0.01f, 1000.0f );

  // eNX`摜̓ǂݍ
  TCHAR dlm[2]=L"\\";
  if(g_sFolder[lstrlen(g_sFolder)-1]==L'\\') dlm[0]=L'\0';
  for(g_pagenum=0;g_pagenum<MAXPAGENUM;g_pagenum++){
    wsprintf(sTextureFile,L"%ls%lsimg%03dl.png",g_sFolder,dlm,g_pagenum+1);
    hr = CreateWICTextureFromFile( g_pd3dDevice, g_pImmediateContext, sTextureFile, nullptr, &g_pShaderResourceViewL[g_pagenum], 0);
    if(FAILED(hr))break;
    wsprintf(sTextureFile,L"%ls%lsimg%03dr.png",g_sFolder,dlm,g_pagenum+1);
    hr = CreateWICTextureFromFile( g_pd3dDevice, g_pImmediateContext, sTextureFile, nullptr, &g_pShaderResourceViewR[g_pagenum], 0);
    wsprintf(sTextureFile,L"%ls%lsimg%03dld.png",g_sFolder,dlm,g_pagenum+1);
    hr = CreateWICTextureFromFile( g_pd3dDevice, g_pImmediateContext, sTextureFile, nullptr, &g_pShaderResourceViewLD[g_pagenum], 0);
    wsprintf(sTextureFile,L"%ls%lsimg%03drd.png",g_sFolder,dlm,g_pagenum+1);
    hr = CreateWICTextureFromFile( g_pd3dDevice, g_pImmediateContext, sTextureFile, nullptr, &g_pShaderResourceViewRD[g_pagenum], 0);
  }
  if(g_pagenum<=0){
    MessageBox(nullptr, L"摜̓ǂݍ݂ł܂łB", L"Err", MB_OK);
    return hr;
  }
  g_step_angle=2.0f*XM_PI/g_pagenum;
  g_now_time=GetTickCount64();
  return S_OK;
}

void CleanupDevice(){
  int i;

  if( g_pImmediateContext ) g_pImmediateContext->ClearState();
  for(i=0;i<g_pagenum;i++){
    if( g_pShaderResourceViewL[i] ) g_pShaderResourceViewL[i]->Release();
    if( g_pShaderResourceViewR[i] ) g_pShaderResourceViewR[i]->Release();
    if( g_pShaderResourceViewLD[i] ) g_pShaderResourceViewLD[i]->Release();
    if( g_pShaderResourceViewRD[i] ) g_pShaderResourceViewRD[i]->Release();
  }
  if( g_pConstantBuffer ) g_pConstantBuffer->Release();
  if( g_pVertexBuffer ) g_pVertexBuffer->Release();
  if( g_pIndexBuffer ) g_pIndexBuffer->Release();
  if( g_pVertexLayout ) g_pVertexLayout->Release();
  if( g_pVertexShader ) g_pVertexShader->Release();
  if( g_pPixelShader ) g_pPixelShader->Release();
  if( g_pDepthStencil ) g_pDepthStencil->Release();
  if( g_pDepthStencilView ) g_pDepthStencilView->Release();
  if( g_pRenderTargetView ) g_pRenderTargetView->Release();
  if( g_pSwapChain ) g_pSwapChain->Release();
  if( g_pImmediateContext ) g_pImmediateContext->Release();
  if( g_pd3dDevice ) g_pd3dDevice->Release();
}

LRESULT CALLBACK WndProc( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam ){
  PAINTSTRUCT ps;
  HDC hdc;

  switch( message ){
  case WM_PAINT:
    hdc = BeginPaint( hWnd, &ps );
    EndPaint( hWnd, &ps );
    break;

  case WM_DESTROY:
    PostQuitMessage( 0 );
    break;

  case WM_KEYDOWN:
	switch(wParam){
	case 'Q':
	case VK_ESCAPE:
      PostQuitMessage( 0 );
	  break;
    case VK_LEFT:
      if(g_nowpage==0) g_nowpage=g_pagenum-1;
  	  else g_nowpage--;
	  g_angle-=g_step_angle;
      break;
    case VK_RIGHT:
  	  g_nowpage++;
	  if(g_nowpage>=g_pagenum) g_nowpage=0;
	  g_angle+=g_step_angle;
      break;
	case VK_SPACE:
	  diffmode=1-diffmode;
	  break;
	}
  default:
    return DefWindowProc( hWnd, message, wParam, lParam );
  }

  return 0;
}

void RenderForOneEye(int eye){
  float r=1.5*g_pagenum/XM_PI;
  XMMATRIX StepTh=XMMatrixRotationY(-g_step_angle);
  XMVECTOR v=XMVector3Transform(XMVectorSet(0.0, 0.0, -r, 0),XMMatrixRotationY(g_now_angle));
  XMVECTOR vpos;
  ConstantBuffer cb1;
  if(eye==0) cb1.mView = XMMatrixTranspose( g_ViewL );
  else cb1.mView = XMMatrixTranspose( g_ViewR );
  cb1.mProjection = XMMatrixTranspose( g_Projection );
  int i;

  for(i=0;i<g_pagenum;i++){
    if(eye==0){
      if(diffmode) g_pImmediateContext->PSSetShaderResources(0, 1, &g_pShaderResourceViewLD[i]);
      else g_pImmediateContext->PSSetShaderResources(0, 1, &g_pShaderResourceViewL[i]);
    } else{
      if(diffmode) g_pImmediateContext->PSSetShaderResources(0, 1, &g_pShaderResourceViewRD[i]);
      else g_pImmediateContext->PSSetShaderResources(0, 1, &g_pShaderResourceViewR[i]);
    }
    vpos=v+XMVectorSet(0.0, 0.0, r, 0.0);
    cb1.mWorld = XMMatrixTranspose(XMMatrixMultiply(g_World,XMMatrixTranslationFromVector(vpos)));
    g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
    g_pImmediateContext->DrawIndexed( 6, 0, 0 );
    v=XMVector3Transform(v,StepTh);
  }
}

void Render(){
  ULONGLONG timeCur = GetTickCount64();
  float dth=(timeCur-g_now_time)/1000.0f*g_step_angle;
  if(g_now_angle<g_angle){
    g_now_angle+=dth;
	if(g_now_angle>g_angle) g_now_angle=g_angle;
  }else if(g_now_angle>g_angle){
    g_now_angle-=dth;
	if(g_now_angle<g_angle) g_now_angle=g_angle;
  }
  g_now_time=timeCur;

  g_pImmediateContext->ClearRenderTargetView( g_pRenderTargetView, Colors::Black );
  g_pImmediateContext->ClearDepthStencilView( g_pDepthStencilView, D3D11_CLEAR_DEPTH, 1.0f, 0 );

  g_pImmediateContext->VSSetShader( g_pVertexShader, nullptr, 0 );
  g_pImmediateContext->VSSetConstantBuffers( 0, 1, &g_pConstantBuffer );
  g_pImmediateContext->PSSetShader( g_pPixelShader, nullptr, 0 );
  g_pImmediateContext->PSSetConstantBuffers( 0, 1, &g_pConstantBuffer );

  // Setup the viewport(L)
  D3D11_VIEWPORT vp;
  vp.Width = (FLOAT)g_width/2;
  vp.Height = (FLOAT)g_height;
  vp.MinDepth = 0.0f;
  vp.MaxDepth = 1.0f;
  vp.TopLeftX = 0;
  vp.TopLeftY = 0;

  // Rencder(L)
  g_pImmediateContext->RSSetViewports( 1, &vp );
  RenderForOneEye(0);

  // Setup the viewport(R)
  vp.TopLeftX = (FLOAT)g_width/2;
  vp.TopLeftY = 0;

  // Rencder(R)
  g_pImmediateContext->RSSetViewports( 1, &vp );
  RenderForOneEye(1);

  g_pSwapChain->Present( 0, 0 );
}
